#property copyright "EXOLON" 
/////////////////////////////////////////////////////////////////////////
//     ,  .//
//     ,   .   //
//   .  -        //
//   4 ,     (   )//                                 
//                         //
//          2 -     //
// up  down.      ,  .//
//          ,   !!!       //
//                                                              EXOLON  //
/////////////////////////////////////////////////////////////////////////


extern double MAGIC1= 12;      //   ,    
extern double MAGIC2= 24;      //    
extern double MaximumRisk        = 0.05;//   
extern double Lots               = 0.01; // 
extern double MinLot      = 0.01;   //   
extern double MAXLOT      = 0.1;  //   
extern int    DecreaseFactor     = 0;   //  (      )
extern double StopLoss=250;   // stoploss
extern double TakeProfit=300;  //  
extern double lTrailingStop  = 100;
extern double sTrailingStop  = 100; 
extern double parabolic_bar = 0;
extern double parabolic_step = 0.02;
extern double xmaporog=5;
extern bool closeotkat  = false;
extern bool closeon4hour  = true;
extern bool SCANMODE  = true;
extern bool UseSound = True;
extern bool UseDay = true;
extern bool Useweekly = true;

extern string NameFileSound = "alert.wav";
int j;

double Spread;

#include <WinUser32.mqh>
#include <stdlib.mqh>  
//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
  
  int buys=0,sells=0;
//----
  for(int i=0;i<OrdersTotal();i++)
    {
    if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
   if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC1||MAGIC2)
           {
    // if(OrderType()==OP_BUY)  buys++;
    //  if(OrderType()==OP_SELL) sells++;
         if(OrderType()==OP_BUYSTOP)  buys++;
        if(OrderType()==OP_SELLSTOP) sells++;
        
       }
    }
//----
   if(buys>0) return(buys);
 else       return(-sells);
  } 


  
 // string SYM = Symbol( );
 //int digits = MarketInfo(SYM, MODE_DIGITS); //    
  
  
//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
double LotsOptimized()

  {
   double lot=Lots;
   int    orders=OrdersHistoryTotal();     
   int    losses=0;                  
//---- 
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,2);
//---- 
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//---- 
   if(lot<MinLot) return (lot);//lot=0.01;
   if(lot>MAXLOT) lot=MAXLOT;
   return(lot);
  }
  
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
  
//---- 
  
   int    ticket;
   double fatlLAST,fatlPREV,rtflLAST,rtflPREV,rbciLAST,rbciPREV,fatlLASTh1,fatlPREVh1,rtflLASTh1,rtflPREVh1,rbciLASTh1,rbciPREVh1,fatlLASTm30,fatlPREVm30,
   rtflLASTm30,rtflPREVm30,rtflLASTd,rtflPREVd, rbciLASTm30,rbciPREVm30,satlPREVm30,satlLASTm30,stlmLASTm30,stlmPREVm30,ftlmLASTm30,ftlmPREVm30,Heiken2m30,Heiken3m30,
   rbciLASTd,rbciPREVd,satlPREV,satlLAST,stlmLAST,stlmPREV, satlPREVh1,satlLASTh1,stlmLASTh1,stlmPREVh1,Heiken2h1,Heiken3h1, Heiken2,Heiken3,satlLASTd,satlPREVd,distart,distop,t1,t2,t3,t4,t5,fatlLASTd,fatlPREVd,Heiken2d,
   Heiken3d, stlmLASTd,stlmPREVd, up, down, upday,downday, priceupl, pricedownl, fatlLASTw,fatlPREVw,
   Heiken2w, Heiken3w, satlLASTw,satlPREVw,rbciLASTw,rbciPREVw,parab, OP1, Take, Stop, OP, tPeriod, global, XMAlast, XMAprev, XMAlasth1, XMAprevh1;
  
  
//----   SELL1 & BUY1 -     atcf ()   
   bool   Sell1=0, Buy1=0;
   
     
//----   SELLd1 & BUYd1 -     dinapoli (1  -     >    1
   bool   Selld1=0, Buyd1 =0;
   
  
//----  SELLd2 & BUYd2 -     dinapoli (2  -      >   ,  2) 
  bool   Selld2=0, Buyd2=0;
  

//----  SELLd3 & BUYd3 -     dinapoli (3  -      1    2 >   ,  2) 
  bool   Selld3=0, Buyd3=0;
  

  //----  SELLd4 & BUYd4 -     dinapoli (4  -      2    3  >   , 
  //----   3) 
    bool   Selld4=0, Buyd4=0;
    
  
  //----  SELLd5 & BUYd5 -     dinapoli (5  -      3    4  >   , 
  //----   4)
    bool   Selld5=0, Buyd5=0;
    
  
  //----  SELLd6 & BUYd6 -     dinapoli (6  -      4    5  50 . >   , 
  //----   5)
  bool   Selld6=0, Buyd6=0;
    
  
  bool   Sell0=0, Buy0=0;  //   
  
  
    
  bool sellw=0, buyw=0, sws=EMPTY_VALUE, swb=EMPTY_VALUE;//   
  
  bool sellD=0, buyD=0, sds=EMPTY_VALUE, sdb=EMPTY_VALUE;//   
  
    
//if(Volume[0]>6) return;
fatlLAST=iCustom(NULL,PERIOD_H4,"fatl",0,0);
fatlPREV=iCustom(NULL,PERIOD_H4,"fatl",0,1);
rtflLAST=iCustom(NULL,PERIOD_H4,"rftl",0,0);
rtflPREV=iCustom(NULL,PERIOD_H4,"rftl",0,1);
rbciLAST=iCustom(NULL,PERIOD_H4,"rbci",0,0);
rbciPREV=iCustom(NULL,PERIOD_H4,"rbci",0,1);
satlPREV=iCustom(NULL,PERIOD_H4,"SATL",0,1);
satlLAST=iCustom(NULL,PERIOD_H4,"SATL",0,0);
stlmLAST=iCustom(NULL,PERIOD_H4,"ftlm-stlm",0,0);
stlmPREV=iCustom(NULL,PERIOD_H4,"ftlm-stlm",0,1);

fatlLASTh1=iCustom(NULL,PERIOD_H1,"fatl",0,0);
fatlPREVh1=iCustom(NULL,PERIOD_H1,"fatl",0,1);
rtflLASTh1=iCustom(NULL,PERIOD_H1,"rftl",0,0);
rtflPREVh1=iCustom(NULL,PERIOD_H1,"rftl",0,1);
rbciLASTh1=iCustom(NULL,PERIOD_H1,"rbci",0,0);
rbciPREVh1=iCustom(NULL,PERIOD_H1,"rbci",0,1);
satlPREVh1=iCustom(NULL,PERIOD_H1,"SATL",0,1);
satlLASTh1=iCustom(NULL,PERIOD_H1,"SATL",0,0);
stlmLASTh1=iCustom(NULL,PERIOD_H1,"ftlm-stlm",0,0);
stlmPREVh1=iCustom(NULL,PERIOD_H1,"ftlm-stlm",0,1);
Heiken2h1=iCustom(NULL,PERIOD_H1,"#HeikenAshi",2,0);
Heiken3h1=iCustom(NULL,PERIOD_H1,"#HeikenAshi",3,0);

fatlLASTm30=iCustom(NULL,PERIOD_M30,"fatl",0,0);
fatlPREVm30=iCustom(NULL,PERIOD_M30,"fatl",0,1);
rtflLASTm30=iCustom(NULL,PERIOD_M30,"rftl",0,0);
rtflPREVm30=iCustom(NULL,PERIOD_M30,"rftl",0,1);
rbciLASTm30=iCustom(NULL,PERIOD_M30,"rbci",0,0);
rbciPREVm30=iCustom(NULL,PERIOD_M30,"rbci",0,1);
satlPREVm30=iCustom(NULL,PERIOD_M30,"SATL",0,1);
satlLASTm30=iCustom(NULL,PERIOD_M30,"SATL",0,0);
stlmLASTm30=iCustom(NULL,PERIOD_M30,"ftlm-stlm",0,0);
stlmPREVm30=iCustom(NULL,PERIOD_M30,"ftlm-stlm",0,1);
Heiken2m30=iCustom(NULL,PERIOD_M30,"#HeikenAshi",2,0);
Heiken3m30=iCustom(NULL,PERIOD_M30,"#HeikenAshi",3,0);

rtflLASTd=iCustom(NULL,PERIOD_D1,"rftl",0,0);
rtflPREVd=iCustom(NULL,PERIOD_D1,"rftl",0,1);

satlLASTw=iCustom(NULL,PERIOD_W1,"SATL",0,0);
satlPREVw=iCustom(NULL,PERIOD_W1,"SATL",0,1);
Heiken2=iCustom(NULL,tPeriod,"#HeikenAshi",2,0);
Heiken3=iCustom(NULL,tPeriod,"#HeikenAshi",3,0);
distart= NormalizeDouble(ObjectGet("Start line",OBJPROP_PRICE1),Digits);
distop= NormalizeDouble(ObjectGet("Stop line",OBJPROP_PRICE1),Digits);
t1=NormalizeDouble(ObjectGet("Target1 line",OBJPROP_PRICE1),Digits);
t2=NormalizeDouble(ObjectGet("Target2 line",OBJPROP_PRICE1),Digits);
t3=NormalizeDouble(ObjectGet("Target3 line",OBJPROP_PRICE1),Digits);
t4=NormalizeDouble(ObjectGet("Fantasy line",OBJPROP_PRICE1),Digits);
t5=NormalizeDouble(ObjectGet("CrazyDream line",OBJPROP_PRICE1),Digits);
//up=NormalizeDouble(ObjectGet("up line",OBJPROP_PRICE1),Digits);
//down=NormalizeDouble(ObjectGet("down line",OBJPROP_PRICE1),Digits);
upday=NormalizeDouble(ObjectGet("up-day",OBJPROP_PRICE1),Digits);
downday=NormalizeDouble(ObjectGet("down-day",OBJPROP_PRICE1),Digits);
priceupl= NormalizeDouble(ObjectGet("priceup",OBJPROP_PRICE1),Digits);
pricedownl=NormalizeDouble(ObjectGet("pricedown",OBJPROP_PRICE1),Digits);
satlLASTd=iCustom(NULL,PERIOD_D1,"SATL",0,0);
satlPREVd=iCustom(NULL,PERIOD_D1,"SATL",0,1);
fatlLASTd=iCustom(NULL,PERIOD_D1,"fatl",0,0);
fatlPREVd=iCustom(NULL,PERIOD_D1,"fatl",0,1);
Heiken2d=iCustom(NULL,PERIOD_D1,"#HeikenAshi",2,0);
Heiken3d=iCustom(NULL,PERIOD_D1,"#HeikenAshi",3,0);
stlmLASTd=iCustom(NULL,PERIOD_D1,"ftlm-stlm",0,0);
stlmPREVd=iCustom(NULL,PERIOD_D1,"ftlm-stlm",0,1);
rbciLASTd=iCustom(NULL,PERIOD_D1,"rbci",0,0);
rbciPREVd=iCustom(NULL,PERIOD_D1,"rbci",0,1);
rbciLASTw=iCustom(NULL,PERIOD_W1,"rbci",0,0);
rbciPREVw=iCustom(NULL,PERIOD_W1,"rbci",0,1);
fatlLASTw=iCustom(NULL,PERIOD_W1,"fatl",0,0);
fatlPREVw=iCustom(NULL,PERIOD_W1,"fatl",0,1);
Heiken2w=iCustom(NULL,PERIOD_W1,"#HeikenAshi",2,0);
Heiken3w=iCustom(NULL,PERIOD_W1,"#HeikenAshi",3,0);
parab=NormalizeDouble (iSAR(NULL,PERIOD_D1,0.02,0.2,0), Digits);
//global=GlobalVariableGet (Symbol());
double blokbay= Ask < priceupl;
double bloksell= Bid > pricedownl;
XMAlast=iCustom(NULL,PERIOD_D1,"XMA",12,xmaporog,1,1,0,0,0);
XMAprev=iCustom(NULL,PERIOD_D1,"XMA",12,xmaporog,1,1,0,0,1);
XMAlasth1=iCustom(NULL,PERIOD_H4,"XMA",12,xmaporog,1,1,0,0,0);
XMAprevh1=iCustom(NULL,PERIOD_H4,"XMA",12,xmaporog,1,1,0,0,1);

//--------  

   sellw = (Heiken2w > Heiken3w  && fatlLASTw < fatlPREVw && satlLASTw < satlPREVw && rbciLASTw < rbciPREVw); // || global==2
   if (Useweekly)  sws = sellw;
   
   
   sellD = fatlLASTd < fatlPREVd && fatlLASTd < rtflLASTd && satlLASTd < satlPREVd  && Heiken2d > Heiken3d && rbciLASTd < rbciPREVd && stlmLASTd < stlmPREVd 
   && (stlmLASTd > downday)&& (XMAlast<XMAprev);
   if (UseDay)  sds = sellD;
   
 
   Sell1=   fatlLAST < fatlPREV && satlLAST < satlPREV && fatlLAST < rtflLAST  && rbciLAST < rbciPREV &&
   Heiken2 > Heiken3 && stlmLAST < stlmPREV && distart < distop  && sws && sds && bloksell;//(stlmLAST > down)
   
   
   ////////
   
     buyw =  (Heiken2w < Heiken3w && fatlLASTw > fatlPREVw && satlLASTw > satlPREVw && rbciLASTw > rbciPREVw); // || global==1
  if (Useweekly) swb = buyw;
  
   buyD = fatlLASTd > fatlPREVd && fatlLASTd > rtflLASTd && satlLASTd > satlPREVd  && Heiken2d < Heiken3d &&  rbciLASTd > rbciPREVd && stlmLASTd > stlmPREVd && (stlmLASTd < upday) && (XMAlast>XMAprev);
   if (UseDay)  sdb=buyD;
  
    Buy1=fatlLAST > fatlPREV && fatlLAST > rtflLAST && satlLAST > satlPREV && rbciLAST > rbciPREV &&
    Heiken2 < Heiken3 && stlmLAST > stlmPREV  &&  distart > distop  && swb && sdb&& blokbay;// &&  (stlmLAST < up) 
 
   
//-------------
   Selld1=Bid>distart;
   Buyd1 =Ask<distart;
   
//------------- 
    Selld2=Bid<=distart && Bid>t1 && distart>t1;  
    Buyd2 =Ask>=distart && Ask<t1 && distart<t1;
    
//------------- 
    Selld3=Bid<=t1 && Bid>t2 && t1>=t2;
    Buyd3 =Ask>=t1 && Ask<t2 && t1<=t2;
       
//------------- 
    Selld4=Bid<t2 && Bid>t3 && t2>=t3;
    Buyd4 =Ask>t2 && Ask<t3 && t2<=t3;
       
//------------- 
   Selld5=Bid<t3 && Bid>t4 && t3>t4;
    Buyd5=Ask>t3 && Ask<t4 && t3<t4;
    
 //------------- 
   Selld6=Bid<t4 && Bid>t5 && t4>t5;
    Buyd6=Ask>t4 && Ask<t5 && t4<t5;   
    
   
    
        
//-------------   

  if (SCANMODE) Sell0 = (fatlLASTh1 < fatlPREVh1 && satlLASTh1 < satlPREVh1 &&  fatlLASTh1 < rtflLASTh1 && rbciLASTh1 < rbciPREVh1 
  && Heiken2h1 > Heiken3h1 && stlmLASTh1 < stlmPREVh1);//&& (fatlLASTm30 < fatlPREVm30 && satlLASTm30 < satlPREVm30 
  //&& fatlLASTm30 < rtflLASTm30 && rbciLASTm30 < rbciPREVm30 && Heiken2m30 > Heiken3m30 && stlmLASTm30 < stlmPREVm30)
  //&&(fatlLAST < rtflLAST && fatlLAST < fatlPREV && satlLAST < satlPREV &&  rbciLAST < rbciPREV 
  //&& Heiken2 > Heiken3 && stlmLAST < stlmPREV)&& (XMAlasth1<XMAprevh1);
  
  // ----------- 
  
   if (SCANMODE) Buy0 =(fatlLASTh1 > fatlPREVh1 && fatlLASTh1 > rtflLASTh1 &&  satlLASTh1 > satlPREVh1 && rbciLASTh1 > rbciPREVh1 
   && Heiken2h1 < Heiken3h1 && stlmLASTh1 > stlmPREVh1);  
  // && (fatlLASTm30 > fatlPREVm30 && fatlLASTm30 > rtflLASTm30 && satlLASTm30 > satlPREVm30 && rbciLASTm30 > rbciPREVm30 && Heiken2m30 < Heiken3m30 && stlmLASTm30 > stlmPREVm30)
  //  && (fatlLAST > rtflLAST && fatlLAST > fatlPREV && satlLAST > satlPREV && rbciLAST > rbciPREV && 
  // Heiken2 < Heiken3 && stlmLAST > stlmPREV)&&(XMAlasth1>XMAprevh1);
   
   

//---- 1 

if(Sell1==1 && Selld1==1 ) OpenOrder(OP_SELLSTOP,distart,distop+Spread,t1+Spread,"SellStop ATCF din1", MAGIC1);
if(Buy1==1 && Buyd1==1)   OpenOrder(OP_BUYSTOP, distart+Spread,distop,t1,"BuyStop ATCF din1", MAGIC1);

//---- 2  
if(Sell1==1 && Selld2==1&& (NumberOfPositions(NULL,OP_SELL,MAGIC1)< 1)) OpenOrder(OP_SELL,Bid,distop+Spread,t1+Spread,"Sell ATCF din2", MAGIC1); 
if (Buy1==1 && Buyd2==1 && (NumberOfPositions(NULL,OP_BUY,MAGIC1)< 1))  OpenOrder(OP_BUY, Ask,distop,t1,"Buy ATCF din2", MAGIC1); 

//---- 3  
if(Sell1==1 && Selld3==1&& (NumberOfPositions(NULL,OP_SELL,MAGIC1)< 1)) OpenOrder(OP_SELL,Bid,Ask+StopLoss*Point,t2+Spread,"Sell ATCF din3", MAGIC1); 
if (Buy1==1 && Buyd3==1&& (NumberOfPositions(NULL,OP_BUY,MAGIC1)< 1))  OpenOrder(OP_BUY, Ask,Bid-StopLoss*Point,t2,"Buy ATCF din3", MAGIC1); 

//---- 4  
if(Sell1==1 && Selld4==1&& (NumberOfPositions(NULL,OP_SELL,MAGIC1)< 1)) OpenOrder(OP_SELL,Bid,Ask+StopLoss*Point,t3+Spread,"Sell ATCF din4", MAGIC1); 
if(Buy1==1 && Buyd4==1&& (NumberOfPositions(NULL,OP_BUY,MAGIC1)< 1))   OpenOrder(OP_BUY, Ask,Bid-StopLoss*Point,t3,"Buy ATC din4", MAGIC1); 

//---- 5  
if(Sell1==1 && Selld5==1&& (NumberOfPositions(NULL,OP_SELL,MAGIC1)< 1)) OpenOrder(OP_SELL,Bid,Ask+StopLoss*Point,t4+Spread,"Sell ATCF din5", MAGIC1); 
if(Buy1==1 && Buyd5==1&& (NumberOfPositions(NULL,OP_BUY,MAGIC1)< 1))   OpenOrder(OP_BUY, Ask,Bid-StopLoss*Point,t4,"Buy ATCF din5", MAGIC1); 

//---- 6  
if(Sell1==1 && Selld6==1&& (NumberOfPositions(NULL,OP_SELL,MAGIC1)< 1)) OpenOrder(OP_SELL,Bid,Ask+StopLoss*Point,t5+Spread,"Sell ATCF din6", MAGIC1); 
if(Buy1==1 && Buyd6==1&& (NumberOfPositions(NULL,OP_BUY,MAGIC1)< 1))   OpenOrder(OP_BUY, Ask,Bid-StopLoss*Point,t5,"Buy ATCF din6", MAGIC1); 


//----- 
if(Sell0==1&& (NumberOfPositions(NULL,OP_SELL,MAGIC2)< 1))  OpenOrder(OP_SELL,Bid,Ask+StopLoss*Point,Bid-TakeProfit*Point,"Sell ATCF SCAN", MAGIC2); 
if(Buy0==1&& (NumberOfPositions(NULL,OP_BUY,MAGIC2)< 1))   OpenOrder(OP_BUY, Ask,Bid-StopLoss*Point,Ask+TakeProfit*Point,"Buy ATCF SCAN", MAGIC2); 


}
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
  
//----
  
   double fatlLAST,rtflLAST,fatlPREV,rtflPREV,rbciLAST,rbciPREV, rbciLASTd,rbciPREVd,
satlPREV,satlLAST,stlmLAST,stlmPREV,ftlmLAST,ftlmPREV,Heiken2,Heiken3,Heiken2d,Heiken3d,fatlLASTd,
fatlPREVd, parab, tPeriod, stlmLASTd,stlmPREVd, upday,downday,fatlLASTw,fatlPREVw,
   Heiken2w, Heiken3w, satlLASTw,satlPREVw,rbciLASTw,rbciPREVw,fatlLASTh1,rtflLASTh1,fatlPREVh1,rtflPREVh1,rbciLASTh1,rbciPREVh1,
fatlLASTh,rtflLASTh,fatlPREVh,rtflPREVh,rbciLASTh,rbciPREVh,satlPREVh,satlLASTh,stlmLASTh,stlmPREVh,
satlPREVh1,satlLASTh1,stlmLASTh1,stlmPREVh1,ftlmLASTh1,ftlmPREVh1,Heiken2h1,Heiken3h1,
Heiken2h,Heiken3h, up, down, satlPREVd,satlLASTd, XMAlast, XMAprev, rtflLASTd, rtflPREVd, Sellwo, Buywo;

bool   Sell1=0, Buy1=0;
bool   Sellcl0=0, Buycl0=0;
bool sellh=0, buyh=0, shs=EMPTY_VALUE, shb=EMPTY_VALUE;//     4 
bool sell4=0, buy4=0, s4s=EMPTY_VALUE, s4b=EMPTY_VALUE;//    

//---- 
 
// if(Volume[0]>1) return;
fatlLAST=iCustom(NULL,PERIOD_H4,"fatl",0,0);
rtflLAST=iCustom(NULL,PERIOD_H4,"rftl",0,0);
fatlPREV=iCustom(NULL,PERIOD_H4,"fatl",0,1);
rtflPREV=iCustom(NULL,PERIOD_H4,"rftl",0,1);
rtflPREVd=iCustom(NULL,PERIOD_D1,"rftl",0,1);
rtflLASTd=iCustom(NULL,PERIOD_D1,"rftl",0,0);
rbciLAST=iCustom(NULL,PERIOD_H4,"rbci",0,0);
rbciPREV=iCustom(NULL,PERIOD_H4,"rbci",0,1);
satlPREV=iCustom(NULL,PERIOD_H4,"SATL",0,1);
satlLAST=iCustom(NULL,PERIOD_H4,"SATL",0,0);
satlPREVd=iCustom(NULL,PERIOD_D1,"SATL",0,1);
satlLASTd=iCustom(NULL,PERIOD_D1,"SATL",0,0);
stlmLAST=iCustom(NULL,PERIOD_H4,"ftlm-stlm",0,0);
stlmPREV=iCustom(NULL,PERIOD_H4,"ftlm-stlm",0,1);
stlmLASTd=iCustom(NULL,PERIOD_D1,"ftlm-stlm",0,0);
stlmPREVd=iCustom(NULL,PERIOD_D1,"ftlm-stlm",0,1);
ftlmLAST=iCustom(NULL,PERIOD_H4,"ftlm-stlm",1,0);
ftlmPREV=iCustom(NULL,PERIOD_H4,"ftlm-stlm",1,1);

Heiken2=iCustom(NULL,PERIOD_H4,"#HeikenAshi",2,0);
Heiken3=iCustom(NULL,PERIOD_H4,"#HeikenAshi",3,0);

fatlLASTh1=iCustom(NULL,PERIOD_H1,"fatl",0,0);
fatlPREVh1=iCustom(NULL,PERIOD_H1,"fatl",0,1);
rtflLASTh1=iCustom(NULL,PERIOD_H1,"rftl",0,0);
rtflPREVh1=iCustom(NULL,PERIOD_H1,"rftl",0,1);
rbciLASTh1=iCustom(NULL,PERIOD_H1,"rbci",0,0);
rbciPREVh1=iCustom(NULL,PERIOD_H1,"rbci",0,1);
satlPREVh1=iCustom(NULL,PERIOD_H1,"SATL",0,1);
satlLASTh1=iCustom(NULL,PERIOD_H1,"SATL",0,0);
stlmLASTh1=iCustom(NULL,PERIOD_H1,"ftlm-stlm",0,0);
stlmPREVh1=iCustom(NULL,PERIOD_H1,"ftlm-stlm",0,1);
ftlmLASTh1=iCustom(NULL,PERIOD_H1,"ftlm-stlm",1,0);
ftlmPREVh1=iCustom(NULL,PERIOD_H1,"ftlm-stlm",1,1);

//up=NormalizeDouble(ObjectGet("up line",OBJPROP_PRICE1),Digits);
//down=NormalizeDouble(ObjectGet("down line",OBJPROP_PRICE1),Digits);
upday=NormalizeDouble(ObjectGet("up-day",OBJPROP_PRICE1),Digits);
downday=NormalizeDouble(ObjectGet("down-day",OBJPROP_PRICE1),Digits);
Heiken2h1=iCustom(NULL,PERIOD_H1,"#HeikenAshi",2,0);
Heiken3h1=iCustom(NULL,PERIOD_H1,"#HeikenAshi",3,0);
Heiken2d=iCustom(NULL,PERIOD_D1,"#HeikenAshi",2,0);
Heiken3d=iCustom(NULL,PERIOD_D1,"#HeikenAshi",3,0);
fatlLASTd=iCustom(NULL,PERIOD_D1,"fatl",0,0);
fatlPREVd=iCustom(NULL,PERIOD_D1,"fatl",0,1);
rbciLASTd=iCustom(NULL,PERIOD_D1,"rbci",0,0);
rbciPREVd=iCustom(NULL,PERIOD_D1,"rbci",0,1);
satlLASTw=iCustom(NULL,PERIOD_W1,"SATL",0,0);
satlPREVw=iCustom(NULL,PERIOD_W1,"SATL",0,1);
fatlLASTw=iCustom(NULL,PERIOD_W1,"fatl",0,0);
fatlPREVw=iCustom(NULL,PERIOD_W1,"fatl",0,1);
Heiken2w=iCustom(NULL,PERIOD_W1,"#HeikenAshi",2,0);
Heiken3w=iCustom(NULL,PERIOD_W1,"#HeikenAshi",3,0);
rbciLASTw=iCustom(NULL,PERIOD_W1,"rbci",0,0);
rbciPREVw=iCustom(NULL,PERIOD_W1,"rbci",0,1);
XMAlast=iCustom(NULL,PERIOD_D1,"XMA",12,xmaporog,1,1,0,0,0);
XMAprev=iCustom(NULL,PERIOD_D1,"XMA",12,xmaporog,1,1,0,0,1);
parab=NormalizeDouble (iSAR(NULL,PERIOD_D1,parabolic_step,0.2,parabolic_bar), Digits);

Sellwo= Heiken2w > Heiken3w  && fatlLASTw < fatlPREVw && satlLASTw < satlPREVw && rbciLASTw < rbciPREVw;
Buywo= Heiken2w < Heiken3w && fatlLASTw > fatlPREVw && satlLASTw > satlPREVw && rbciLASTw > rbciPREVw;
//---- SELLh & BUYh -      ()
//if (XMAlast==XMAprev) closeotkat = true;         //      . 
//if (stlmLASTd < downday) closeotkat = true;      //
//if (stlmLASTd > upday) closeotkat = true;        //
//if (ftlmLASTd < downday) closeotkat = true;      //
//if (ftlmLASTd > upday) closeotkat = true;        //
//if (Sellwo !=1 && Buywo !=1) closeotkat = true;    //

if (closeotkat) sellh = fatlLAST < fatlPREV && Heiken2 > Heiken3 && rbciPREV > rbciLAST && fatlLAST < rtflLAST && stlmLAST < stlmPREV
 && satlLAST < satlPREV && fatlLASTd < fatlPREVd && rbciPREVd > rbciLASTd;
    
 
 if (closeotkat) buyh = Heiken2 < Heiken3 && fatlLAST > fatlPREV && rbciPREV < rbciLAST && fatlLAST > rtflLAST && stlmLAST > stlmPREV 
 && satlLAST > satlPREV  && fatlLASTd > fatlPREVd && rbciPREVd < rbciLASTd; 
  
  
//---- SELL4 & BUY4 -     4h ()

if (closeon4hour) sell4 = (Heiken2 > Heiken3  && fatlLAST < fatlPREV && rbciPREV > rbciLAST && stlmLAST < stlmPREV
 && satlLAST < satlPREV && fatlLAST < rtflLAST && fatlLASTd < fatlPREVd  && Heiken2d > Heiken3d && rbciPREVd > rbciLASTd && satlLASTd < satlPREVd )|| (XMAlast<XMAprev);
   
if (closeon4hour) buy4 =  (Heiken2 < Heiken3   && fatlLAST > fatlPREV  && stlmLAST > stlmPREV && rbciPREV < rbciLAST &&
   satlLAST > satlPREV && fatlLAST > rtflLAST && fatlLASTd > fatlPREVd  && Heiken2d < Heiken3d && rbciPREVd < rbciLASTd  && satlLASTd > satlPREVd )|| (XMAlast>XMAprev);
  

//----    ()

Sell1 = (fatlLASTd < fatlPREVd  && Heiken2d > Heiken3d && rbciPREVd > rbciLASTd && satlLASTd < satlPREVd && stlmLASTd <= stlmPREVd) || sellh || sell4; 
Buy1 =  (fatlLASTd > fatlPREVd  && Heiken2d < Heiken3d && rbciPREVd < rbciLASTd && satlLASTd > satlPREVd && stlmLASTd >= stlmPREVd) || buyh || buy4;

 
 //----    
if (SCANMODE) Sellcl0 = fatlLASTh1 < fatlPREVh1  && Heiken2h1 > Heiken3h1 && rbciPREVh1 > rbciLASTh1 && satlLASTh1 < satlPREVh1 && stlmLASTh1 < stlmPREVh1 && fatlLASTh1 < rtflLASTh1; 
// && fatlLAST < fatlPREV && Heiken2 > Heiken3 && rbciPREV > rbciLAST && satlLAST < satlPREV && stlmLAST < stlmPREV); 

if (SCANMODE) Buycl0 = fatlLASTh1 > fatlPREVh1  && Heiken2h1 < Heiken3h1 && rbciPREVh1 < rbciLASTh1 && satlLASTh1 > satlPREVh1 && stlmLASTh1 > stlmPREVh1 && fatlLASTh1 > rtflLASTh1;
//  && fatlLAST > fatlPREV && Heiken2 < Heiken3 && rbciPREV < rbciLAST && satlLAST > satlPREV && stlmLAST > stlmPREV);

  
    
  if (Sell1==1)  ClosePositions (NULL,OP_BUY,MAGIC1);
    if (Buy1==1) ClosePositions(NULL,OP_SELL,MAGIC1);       
     if (Sellcl0==1) ClosePositions (NULL,OP_BUY,MAGIC2);
     if (Buycl0==1) ClosePositions (NULL,OP_SELL,MAGIC2);
  
    
   
   
     // MODIFICATION -------
     
     TrailingPositionsBuy(parab);
    TrailingPositionsSell(parab);
   // TrailingPositionsBuystop(parab);
   // TrailingPositionsSellstop(parab);
    return (0);
   }
/*bool ExistPositions() {
   for (int i=0; i<OrdersTotal(); i++) {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
            return(True);
         }
      } 
   } 
   return(false);
}*/
     
void TrailingPositionsBuy(double parab)
 { 
   for (int i=0; i<OrdersTotal(); i++) 
   { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
       { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC1)
          { 
            if (OrderType()==OP_BUY) 
            { 
             //  if (Bid-OrderOpenPrice()>trailingStop*Point) { 
              //    if (OrderStopLoss()<Bid-trailingStop*Point) 
                     ModifyStopLoss(parab);
                                   
               } 
            } 
         } 
      } 
   } 
//} 
void TrailingPositionsSell(double parab) 
{ 
   for (int i=0; i<OrdersTotal(); i++) 
   { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
       { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC1)
          { 
            if (OrderType()==OP_SELL)
             { 
             //  if (OrderOpenPrice()-Ask>trailingStop*Point) { 
             //     if (OrderStopLoss()>Ask+trailingStop*Point || OrderStopLoss()==0)  
                     ModifyStopLoss(parab);
                  
               } 
            } 
         } 
      } 
   } 
//} 
//double OP1, Take, Stop;

//void TrailingPositionsSellstop(double parab) { 
  // for (int i=0; i<OrdersTotal(); i++) { 
   //   if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
    //     if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC2) {
   //  if (OrderType()==OP_SELLSTOP) {
                   
    //    OP1 = NormalizeDouble (iSAR(NULL,PERIOD_H4,0.02,0.2,0), Digits);  //     .
   //     Take = OP1 + TakeProfit*Point; //   .
   //     Stop = OP1 - StopLoss*Point; //  
   //    ModifyStopLoss(parab);     
     
       //        } 
     //       } 
    //     } 
   //   } 
 //  } 
//} 


//void TrailingPositionsBuystop(double parab) { 
  // for (int i=0; i<OrdersTotal(); i++) { 
   //   if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
     //    if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC2) {
    // if (OrderType()==OP_BUYSTOP) {
                   
     //   OP1 = NormalizeDouble (iSAR(NULL,PERIOD_H4,0.02,0.2,0), Digits);  //     .
    //    Take = OP1 + TakeProfit*Point; //   .
     //   Stop = OP1 - StopLoss*Point; //  
    //   ModifyStopLoss(parab);     
     
        //       } 
      //      } 
     //    } 
    //  } 
  // } 
//} 

void ModifyStopLoss(double ldStopLoss) { 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE); 
   if (fm && UseSound) PlaySound(NameFileSound);
   
//----
  }
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
//---- calculate open orders by current symbol
   Spread=Ask-Bid;
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();
   else                                    CheckForClose();
//----
  }
//+------------------------------------------------------------------+
void OpenOrder(int cmd,double OP,double SL,double TP,string com, int magic)
   {
int ticket=OrderSend(Symbol(),cmd,LotsOptimized(),OP,15,SL,TP,com,magic,0);
   if(ticket>0)
      {
      if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) { Print(com+" opened: ",OrderOpenPrice());}
  //    GlobalVariableDel(Symbol());
      
      if (UseSound) PlaySound(NameFileSound); 
      SendMail("fxstart",com+Symbol()+TP);
      }
   else Print(com+" error opening: ",GetLastError());
   return(0); 
   }
   
  

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.02.2008                                                     |
//|   :   .                                 |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
int NumberOfPositions(string sy="", int op=-1, int mn=-1) {
  int i, k=OrdersTotal(), kp=0;

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) kp++;
          }
        }
      }
    }
  }
  return(kp);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|    : 19.02.2008                                                      |
//|  :                      |
//+----------------------------------------------------------------------------+
void ClosePosBySelect() {
  bool   fc;
  color  clClose;
  double ll, pa, pb, pp;
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), err, it;

  if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
    for (it=1; it<=15; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      pa=MarketInfo(OrderSymbol(), MODE_ASK);
      pb=MarketInfo(OrderSymbol(), MODE_BID);
      if (OrderType()==OP_BUY) {
        pp=pb; clClose=Blue;
      } else {
        pp=pa; clClose=Red;
      }
      ll=OrderLots();
      pp=NormalizeDouble(pp, dg);
      fc=OrderClose(OrderTicket(), ll, pp, 10, clClose);
      if (fc) {
        if (UseSound) PlaySound("ok.wav"); break;
      } else {
        err=GetLastError();
        if (UseSound) PlaySound("timeout.wav");
        if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
        Print("Error(",err,") Close ",GetNameOP(OrderType())," ",
              ErrorDescription(err),", try ",it);
        Print(OrderTicket(),"  Ask=",pa,"  Bid=",pb,"  pp=",pp);
        Print("sy=",OrderSymbol(),"  ll=",ll,"  sl=",OrderStopLoss(),
              "  tp=",OrderTakeProfit(),"  mn=",OrderMagicNumber());
        Sleep(1000*5);
      }
    }
  } 
  else Print("  . Close ",GetNameOP(OrderType()));
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.02.2008                                                     |
//|   :                                   |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
void ClosePositions(string sy="", int op=-1, int mn=-1) {
  int i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (mn<0 || OrderMagicNumber()==mn) ClosePosBySelect();
        }
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("BuyLimit");
    case OP_SELLLIMIT: return("SellLimit");
    case OP_BUYSTOP  : return("BuyStop");
    case OP_SELLSTOP : return("SellStop");
    default          : return("Unknown Operation");
  }
}

